<template>

  <section class="fscreen">
    <div class="fscreen__wrapper">
      <header class="header">
        <div class="header__container">
          <img src="@/assets/images/logo.png" alt="" class="header__logo">
          <p class="header__logo-name">CryptoUnicorn</p>
        </div>
        <div class="header__container">
          <router-link to="/register" class="header__btn-reg">Регистрация</router-link>
          <router-link to="/login" class="header__btn-auth">Войти</router-link>
        </div>
      </header>
      <div class="fscreen__content">
        <div class="fscreen__container">
          <h1 class="fscreen__title">Анализируй <span>данные криптовалют</span> вместе с нами</h1>
          <p class="fscreen__desc">
            Lorem ipsum dolor sit amet, consectetur adipiscing elit ut aliquam, purus sit amet luctus venenatis, lectus magna fringilla urna, porttitor
          </p>
        </div>
        <div class="fscreen__container">
          <div class="fscreen__shadow">
            <img src="@/assets/images/fscreen__coin.png" alt="Монета" class="fscreen__image">
          </div>
        </div>
      </div>
    </div>
  </section>

  <div class="cryptolist-sort">
    <div class="cryptolist-sort__wrapper">

      <div class="cryptolist-sort__container">

        <vs-select placeholder="Сортировка по" v-model="shopSortBy">
          <vs-option label="Дате" value="date">
            Дате
          </vs-option>
          <vs-option label="Цене (убывание)" value="price_low">
            Цене (убывание)
          </vs-option>
          <vs-option label="Цене (возрастание)" value="price_high">
            Цене (возрастание)
          </vs-option>
          <vs-option label="Площади (убывание)" value="square_low">
            Площади (убывание)
          </vs-option>
          <vs-option label="Площади (возрастание)" value="square_high">
            Площади (возрастание)
          </vs-option>
        </vs-select>

      </div>

      <div class="cryptolist-sort__container">

        <p class="cryptolist-sort__title">Показывать</p>

        <vs-button
            transparent
            :active="shopSortNum == 12"
            @click="shopSortNum = 12"
        >
          12
        </vs-button>

        <vs-button
            transparent
            :active="shopSortNum == 24"
            @click="shopSortNum = 24"
        >
          24
        </vs-button>

        <vs-button
            transparent
            :active="shopSortNum == 36"
            @click="shopSortNum = 36"
        >
          36
        </vs-button>

        <vs-button
            transparent
            :active="shopSortNum == 48"
            @click="shopSortNum = 48"
        >
          48
        </vs-button>

      </div>

      <div class="cryptolist-sort__container">

        <vs-input class="inputx" placeholder="Поиск.." v-model="value1"/>

      </div>

    </div>

  </div>

  <section class="crypto-list">
    <div class="crypto-list__wrapper">
      <div class="crypto-list__table">
        <div class="crypto-list__table-head">
          <p class="crypto-list__table-head-title">Криптовалюта</p>
          <p class="crypto-list__table-head-title">Цена</p>
          <p class="crypto-list__table-head-title">График</p>
        </div>
        <div class="crypto-list__table-body" v-for="(cryptoListItem, id) in shopPaginated" :key="`crypto-${id}`">
          <div class="crypto-list__table-body-crypt">
            <img :src="'https://cryptocompare.com' + cryptoListItem.image_url" alt="BTC иконка" class="crypto-list__table-body-crypt-icon">
            <div class="crypto-list__table-body-crypt-el">
              <p class="crypto-list__table-body-crypt-el-shortname">{{ cryptoListItem.short_name }}</p>
              <p class="crypto-list__table-body-crypt-el-fullname">{{ cryptoListItem.name }}</p>
            </div>
          </div>
          <p class="crypto-list__table-body-price">{{ cryptoListItem.price }}</p>
          <div class="crypto-list__table-body-graph">
            <img src="@/assets/images/graph.png" alt="График криптовалюты" class="crypto-list__table-body-graph-image">
          </div>
        </div>
      </div>
      <div>
      </div>
      <div class="crypto-list__pagination">
        <vs-pagination :total="cryptoListPageCount" v-model="cryptoListPage" :max="5"></vs-pagination>
      </div>

    </div>
  </section>

  <footer class="footer">
    <div class="footer__wrapper">
      <p class="footer__copyright">© 2022 «CryptoUnicorn»</p>
      <p class="footer__developer">Создано командой Nibble</p>
    </div>
  </footer>


</template>

<script>
import axios from "axios";

let siteUrl = 'https://api.nibbleteam.ru'

export default {
  name: 'MainView',
  data() {
    return {
      cryptoList: [],
      cryptoListError: false,
      cryptoListLoading: true,
      cryptoListSortNum: 10,
      cryptoListPage: 1,
      cryptoListPageCount: 0,
    }
  },
  async mounted() {
    axios
        .get(siteUrl + '/api/getCurrency', {
          params: {},
        })
        .then((response) => {
          this.cryptoList = response.data.data
        })
        .catch((error) => {
          console.log(error)
          this.cryptoListError = true
        })
        .finally(() => (this.cryptoListLoading = false))
  },
  computed: {
    shopPageCountFunc: function () {

      let l = this.cryptoList.length,
          s = this.cryptoListSortNum;
      return this.cryptoListPageCount = Math.ceil(l/s);

    },
    shopPaginated: function () {

      if(this.cryptoList.length === 0) {
        return this.cryptoList
      } else {
        const start = (this.cryptoListPage * this.cryptoListSortNum) - this.cryptoListSortNum,
            end = this.cryptoListPage * this.cryptoListSortNum;

        return this.cryptoList.slice(start, end);
      }

    },
  }
}
</script>

<style lang="scss" scoped>

.fscreen {
  width: 100%;
  background: linear-gradient(90deg, #101010 28.47%, #433265 78.66%, #4B2D86 100%);

  &__wrapper {
    margin: 0 auto;
    width: 90%;
  }

  &__content {
    padding: 6vw 0;
    display: flex;
    justify-content: space-between;
    align-items: center;
    flex-wrap: wrap;
  }

  &__container {
    width: calc(50% - 1vw);
    display: flex;
    flex-direction: column;
    justify-content: center;
  }

  &__title {
    font-size: 3vw;
    font-weight: 700;
    color: #fff;
  }

  &__title > span {
    font-weight: 800;
    color: #C4B234;
  }

  &__desc {
    margin-top: 1.2vw;
    font-size: 1vw;
    font-weight: 500;
    color: #fff;
  }

  &__shadow {
    margin: auto;
    padding: 0 4vw;
    background: radial-gradient(50% 50% at 50% 50%, #4B2D86 43.23%, rgba(75, 45, 134, 0) 100%);
    display: flex;
    box-sizing: border-box;

    &-image {
      margin: auto;
      max-width: 100%;
    }
  }

}

.header {
  padding-top: 2vw;
  display: flex;
  justify-content: space-between;
  align-items: center;

  &__container {
    width: calc(50% - 1vw);
    display: flex;
    align-items: center;

    &:last-of-type {
      justify-content: flex-end;
    }
  }

  &__logo {
    width: 3.5vw;
    border-radius: 50%;
    background-color: #dedede;

    &-name {
      margin-left: 1vw;
      font-size: 1vw;
      font-weight: 500;
      color: #fff;
    }
  }

  &__btn-reg {
    padding: .6vw 1.5vw;
    font-size: 1vw;
    font-weight: 400;
    color: #fff;
    border: 2px solid #C4B234;
    border-radius: 10vw;
    transition: all 1s;

    &:hover {
      background-color: #C4B234;
      box-shadow: 0px 0px 15px 10px rgba(255, 255, 255, 0.2);
    }
  }

  &__btn-auth {
    margin-left: 2vw;
    padding: .6vw 1.5vw;
    font-size: 1vw;
    font-weight: 400;
    color: #101010;
    background-color: #fff;
    border: 2px solid #ffffff00;
    border-radius: 10vw;
    display: block;
    transition: all 1s;

    &:hover {
      border: 2px solid #ffffff;
      box-shadow: 0px 0px 15px 10px rgba(255, 255, 255, 0.2);
    }
  }
}


.cryptolist-sort {
  margin-top: 8vw;
  margin-bottom: 1vw;
  width: 100%;

  &__wrapper {
    margin: 0 auto;
    padding: 1vw 1.5vw;
    width: 90%;
    background-color: #fff;
    border-radius: 10px;
    box-shadow: 0px 0px 15px 10px #10101010;
    display: flex;
    justify-content: space-between;
    align-items: center;
    box-sizing: border-box;
  }

  &__container {
    width: calc(33.33% - 1vw);
    display: flex;
    align-items: center;
    gap: 1vw;
  }
}


.crypto-list {


  &__wrapper {
    margin: 0 auto;
    width: 90%;
  }

  &__table {
    padding: 2vw;
    background-color: #fff;
    box-shadow: 0px 0px 15px 10px #10101010;
    border: 2px solid #dedede;
    border-radius: 10px;
    box-sizing: border-box;

    &-head {
      padding: 1vw 1vw;
      display: flex;
      justify-content: space-between;
      align-items: center;
      gap: 1vw;
      box-sizing: border-box;

      &-title {
        width: calc(33.33% - 1vw);
        font-size: .9vw;
        font-weight: 600;
        color: #101010;
      }
    }

    &-body {
      padding: .5vw 1vw;
      display: flex;
      justify-content: space-between;
      align-items: center;
      gap: 1vw;
      border-radius: 20px;
      box-sizing: border-box;

      &:nth-child(even) {
        background-color: #efefef;
      }

      &-crypt {
        width: calc(33% - 1vw);
        display: flex;
        align-items: center;

        &-icon {
          width: 3vw;
        }

        &-el {
          margin-left: 1vw;

          &-shortname {
            font-size: 1.2vw;
            font-weight: 500;
            color: #101010;
          }

          &-fullname {
            margin-top: .2vw;
            font-size: .8vw;
            font-weight: 400;
            color: #101010da;
          }
        }
      }

      &-price {
        width: calc(33% - 1vw);
        font-size: 1.2vw;
        font-weight: 500;
        color: #101010;

        &:before {
          content: '$';
        }
      }

      &-graph {
        width: calc(33% - 1vw);

        &-image {
          max-width: 8vw;
        }
      }
    }
  }

  &__pagination {
    margin: 0 auto;
  }

  .vs-pagination-primary {
    margin-top: 2vw;
    width: 100%;
  }

}

.footer {
  margin-top: 4vw;
  width: 100%;
  background-color: #fff;
  box-shadow: 0px 0px 4px rgba(0, 0, 0, 0.04), 0px -8px 16px rgba(0, 0, 0, 0.08);

  &__wrapper {
    margin: 0 auto;
    padding: 1.5vw 0;
    width: 90%;
    display: flex;
    justify-content: space-between;
  }

  &__copyright {
    width: calc(50% - 1vw);
    font-size: .9vw;
    font-weight: 500;
    color: #101010;
  }

  &__developer {
    width: calc(50% - 1vw);
    font-size: .9vw;
    font-weight: 500;
    color: #101010;
    text-align: right;
  }

}

@media screen and (max-width: 650px) {

  .fscreen {

    &__content {
      padding: 12vw 0;
    }

    &__title {
      font-size: 8vw;
    }

    &__desc {
      margin-top: 4vw;
      font-size: 3vw;
    }

    &__image {
      display: none;
    }

    &__container {
      width: 100%;
    }
  }

  .header {

    &__logo {
      width: 12vw;

      &-name {
        margin-left: 2vw;
        font-size: 3vw;
      }
    }

    &__btn-reg {
      padding: 1.5vw 4vw;
      font-size: 3vw;
    }

    &__btn-auth {
      padding: 1.5vw 4vw;
      font-size: 3vw;
    }
  }

  .cryptolist-sort {
    margin-top: 16vw;
    margin-bottom: 2vw;

    &__wrapper {
      padding: 4vw;
      flex-direction: column;
      box-sizing: border-box;
    }

    &__container {
      width: 100%;
    }

  }

  .crypto-list {
    &__table {

      &-head {
        padding: 2vw;
        gap: 2vw;

        &-title {
          font-size: 2.8vw;
        }
      }

      &-body {
        padding: 2vw;
        gap: 2vw;
        border-radius: 10px;

        &-crypt {
          &-icon {
            width: 6vw;
          }

          &-el {
            &-shortname {
              font-size: 3.5vw;
            }

            &-fullname {
              margin-top: .5vw;
              font-size: 2.6vw;
            }
          }
        }

        &-price {
          font-size: 3.5vw;
        }

        &-graph {
          &-image {
            max-width: 100%;
          }
        }

      }
    }
  }

  .footer {
    &__wrapper {
      padding: 3vw 0;
    }

    &__copyright {
      font-size: 2.8vw;
    }

    &__developer {
      font-size: 2.8vw;
    }
  }

}


</style>